#detects if a ufo was hit by a projectile


tag @s add salien.hitCompare
execute at @s as @e[type=#minecraft:impact_projectiles,distance=..2.6] run tag @s add salien.hasHitNew
execute as @a if score @s salien.id = @e[type=minecraft:interaction,tag=salien.hitCompare,limit=1] salien.id run tag @s add salien.ufoOwner

#store owner data
data modify storage salien:storage uuid set from entity @e[tag=salien.hasHitNew,sort=nearest,limit=1] Owner

execute at @s as @e[type=#minecraft:impact_projectiles,distance=..2.6] run tag @s add salien.hasHit
execute at @s as @e[type=#minecraft:impact_projectiles,distance=..2.6] run tag @s remove salien.hasHitNew

#compares UUID
execute store result score #checker salien.id run data modify storage salien:storage uuid set from entity @p[tag=salien.ufoOwner] UUID
execute unless score #checker salien.id matches 0 run tag @s add salien.hit

#vfx
execute if entity @s[tag=salien.hit] run particle minecraft:campfire_cosy_smoke ~ ~1 ~ 0.5 0.5 0.5 0.02 20 force
execute if entity @s[tag=salien.hit] run particle minecraft:explosion ~ ~1 ~ 0.1 0.1 0.1 0.05 2 force
execute if entity @s[tag=salien.hit] run particle minecraft:flame ~ ~1 ~ 0.5 0.5 0.5 0 30 force

execute if entity @s[tag=salien.hit] run playsound minecraft:entity.zombie.attack_iron_door neutral @a[distance=..16] ~ ~ ~ 1 2
execute if entity @s[tag=salien.hit] run playsound minecraft:entity.illusioner.cast_spell neutral @a[distance=..16] ~ ~ ~ 1 1.5
execute if entity @s[tag=salien.hit] run playsound minecraft:item.trident.riptide_1 neutral @a[distance=..16] ~ ~ ~ 2 2

#run if the ufo owner was charging their hyperdrive
execute as @p[tag=salien.ufoOwner] store result score #checker salien.id run resource get @s salien:hyperdrive_check_key
execute as @p[tag=salien.ufoOwner] unless score #checker salien.id matches 0 run scoreboard players operation @s salien.hyperdrive *= #2 salien.hyperdrive
execute as @p[tag=salien.ufoOwner] unless score #checker salien.id matches 0 run resource operation @s salien:hyperdrive_cooldown = @s salien.hyperdrive
execute as @p[tag=salien.ufoOwner] unless score #checker salien.id matches 0 run resource set @s salien:hyperdrive_resource 0

#dismount players
execute at @s if entity @s[tag=salien.hit] as @a[sort=nearest,distance=..1] run ride @s dismount
execute at @s if entity @s[tag=salien.hit] as @a[sort=nearest,distance=..1] if score @s salien.id = @e[type=minecraft:interaction,tag=salien.hit,sort=nearest,limit=1] salien.id run resource set @s salien:eject_cooldown 0

#reset ufo motion
execute at @s as @e[type=minecraft:armor_stand,tag=salien.ufo,sort=nearest] if score @s salien.id = @e[type=minecraft:interaction,tag=salien.hitCompare,limit=1] salien.id run data modify entity @s Motion set value 0
execute at @s as @e[type=minecraft:armor_stand,tag=salien.ufo,sort=nearest] if score @s salien.id = @e[type=minecraft:interaction,tag=salien.hitCompare,limit=1] salien.id run forceload add ~ ~ ~ ~

tag @e[tag=salien.ufoOwner] remove salien.ufoOwner
tag @s remove salien.hitCompare
tag @s remove salien.hit